module _ProfileBlockPDPS

include("BlockPDPS.jl");
using .BlockPDPS
using Profile
#using ProfileView

Profile.init(n = 10^7, delay = 0.001)

# First compile...
BlockPDPS.test_dti_helix(maxiter=1)

# ... then profile
@profile begin
    @timev BlockPDPS.test_dti_helix(maxiter=300)
end

open("profile.txt", "w") do io
    Profile.print(IOContext(io, :displaysize => (24, 500)),
                  maxdepth=9,
                  combine=true,
                  mincount=100)
end

open("profile_flat.txt", "w") do io
    Profile.print(IOContext(io, :displaysize => (24, 500)),
                  maxdepth=8,
                  combine=true,
                  format=:flat,
                  sortedby=:count,
                  mincount=100)
end

# ProfileView is useless. Gtk is shit, and all viewers die on the massive SVG.
#ProfileView.svgwrite("profile.svg")

end # module


