
# Diffusion tensor imaging codes from “Primal-dual block-proximal splitting for a class of non-convex problems”

These are the Julia codes for the diffusion tensor imaging experiments of the manuscript _“Primal-dual block-proximal splitting for a class of non-convex problems”_ by S. Mazurenko, J. Jauhiainen, and T. Valkonen. The codes were written by T. Valkonen. 

## Prerequisites

These codes we written for Julia 1.1 but are known to work with Julia 1.2. The Julia package prequisites are from May 2019 when our experiments were run, and have not been updated to maintain the same environment we used to do the experiments in the manuscript. You may get Julia from https://julialang.org/. 

To generate the Helix test data (the data we have generated are included), the Teem toolkit is needed. You may download it from https://sourceforge.net/projects/teem/. Please note that the version included in Homebrew is missing the `emap` binary that is required for the visualisation; indeed as of May 2019 the building of this binary is disabled in Teem. You will therefore need to build Teem manually from source, applying the included `teem-1.11.0-emap_build_fix.patch`. In your unix shell, in the top-level directory of the Teem toolkit source codes, run:

    $ patch -p1 < path_to_these_codes/teem-1.11.0-emap_build_fix.patch

Then build and install Teem according to instructions.

The visualisation further requires the `open -g` to open the generated PDF file in a PDF viewer that will correctly refresh the file on further launches. This is the case on MacOS with _Preview_ or _Skim_.

## Using

Navigate your unix shell to the directory containing this README.md and then run:

    $ julia --project=BlockPDPS

Afterwards in the Julia shell, type:

    > using BlockPDPS

This may take a while as Julia builds any missing dependencies. Then, to run the default experiments, run:

    > test_dti_helix(visualise=true)

This will use any cached data in the `data/` subdirectory of the current working directory. If no cached data is found, new data will be generated using Teem. If you use provided data and set `visualise=false`, the Teem dependency will be removed. The results are saved under the `img/` subdirectory of the current working directory.

The `test_dti_helix` function has further parameters; please see the source code for details.


